<!DOCTYPE html>
<html>

<head>
  <title>Binary Negation App</title>
  <script src="https://unpkg.com/vue@2.6.14/dist/vue.js"></script>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>

<body>
  <div id="app">
    <h1 class="alert alert-success">Binary Negation App</h1>
    <label for="binaryInput" class="h2">Enter a binary string:</label>
    <input class="form-control" type="text" v-model="binaryString" id="binaryInput" @input="onInputChange" />

    <p>Original Binary: {{ binaryString }}</p>
    <p>Negated Binary: {{ negatedBinary }}</p>
  </div>

  <script>
    new Vue({
      el: '#app',
      data: {
        binaryString: '',
        negatedBinary: '',
      },
      methods: {
        onInputChange() {
          this.negateBinary();
        },
        negateBinary() {
          if (!this.binaryString) {
            this.negatedBinary = '';
            return;
          }

          // Validate the input to make sure it is a valid binary string
          const binaryRegex = /^[01]+$/;
          if (!this.binaryString.match(binaryRegex)) {
            this.negatedBinary = 'Invalid binary string';
            return;
          }

          // Perform the negation by flipping each bit
          const negatedBinaryArray = this.binaryString
            .split('')
            .map(bit => (bit === '0' ? '1' : '0'));

          this.negatedBinary = negatedBinaryArray.join('');
        },
      },
    });
  </script>
</body>

</html>
